// OK
#include <iostream>
#include <fstream>
#include <vector>
#include <stack>
using namespace std;

ofstream fout("graf.out");

using VI  = vector<int>;
using VVI = vector<VI>;
using VIt = vector<VI::iterator>;
using VB  = vector<bool>;

VVI G;
int n;

void CitesteGraf();
void Dfs(int x);

int main()
{
	CitesteGraf();
	Dfs(1);
}

void Dfs(int x)
{
	VB v = VB(n + 1);
	VIt p = VIt(n + 1);
	
	for (int i = 1; i <= n; ++i)
		p[i] = G[i].begin();
	
	stack<int> stk;
	stk.push(x); 
	v[x] = true;
	fout << x << ' ';
	
	while (!stk.empty())
	{
		x = stk.top();
		if (p[x] == G[x].end())
			stk.pop();
		else	
			if (p[x] != G[x].end())
			{
				int y = *p[x]++;					
				if (v[y]) continue;		
				v[y] = true;
				fout << y << ' ';
				
				stk.push(y); 
			}
	}
}

void CitesteGraf()
{
	ifstream fin("graf.in");
	
	fin >> n;
	G = VVI(n + 1);
	int x, y;
	while (fin >> x >> y)
	{
		G[x].push_back(y);
		G[y].push_back(x);
	}
}
